> ## Documentation Index
> Fetch the complete documentation index at: https://docs.primefreight.com/llms.txt
> Use this file to discover all available pages before exploring further.

# Get container raw events

> Retrieve raw event data for a specific container

# Get container raw events

Retrieves the raw event data for a container by its ID. Raw events provide the most detailed event information available, including original event descriptions from carrier systems.
Get a list of past and future (estimated) milestones for a container as reported by the carrier.

For past events we recommend consuming transport\_events.

## Endpoint Overview

**GET** `/containers/{id}/raw_events`

This endpoint returns comprehensive raw event data with timestamps, locations, vessel information, and original event descriptions.

## Request Format

### Headers

| Header      | Type   | Required | Description                     |
| ----------- | ------ | -------- | ------------------------------- |
| `X-API-Key` | string | Yes      | Your API key for authentication |

### Path Parameters

| Parameter | Type   | Required | Description                            |
| --------- | ------ | -------- | -------------------------------------- |
| `id`      | string | Yes      | The unique identifier of the container |

## Response Format

### Success Response (200 OK)

```json theme={null}
{
  "data": [
    {
      "id": "ca6b760f-13e9-4bf6-ab49-3cf2e40757fb",
      "type": "raw_event",
      "attributes": {
        "timestamp": "2020-03-03T00:00:00Z",
        "estimated": false,
        "actual_on": "2020-03-03",
        "estimated_at": null,
        "actual_at": null,
        "event": "empty_out",
        "index": 0,
        "original_event": "Truck Gate out empty",
        "created_at": "2020-04-18T00:18:27Z",
        "voyage_number": null,
        "location_name": "Oakland",
        "location_locode": null,
        "vessel_name": null,
        "vessel_imo": null,
        "timezone": null
      },
      "relationships": {
        "location": {
          "data": null
        },
        "vessel": {
          "data": null
        }
      }
    },
    {
      "id": "bcdfc796-0570-4c85-9336-d6c7d0da02d2",
      "type": "raw_event",
      "attributes": {
        "timestamp": "2020-03-09T00:00:00Z",
        "estimated": false,
        "actual_on": "2020-03-09",
        "estimated_at": null,
        "actual_at": null,
        "event": "full_in",
        "index": 1,
        "original_event": "Truck Arrival in",
        "created_at": "2020-04-18T00:18:27Z",
        "voyage_number": null,
        "location_name": null,
        "location_locode": null,
        "vessel_name": null,
        "vessel_imo": null,
        "timezone": null
      },
      "relationships": {
        "location": {
          "data": null
        },
        "vessel": {
          "data": null
        }
      }
    },
    {
      "id": "a4ff01b0-b374-4123-ae65-3dc0c7ea41ea",
      "type": "raw_event",
      "attributes": {
        "timestamp": "2020-03-14T00:00:00Z",
        "estimated": false,
        "actual_on": "2020-03-14",
        "estimated_at": null,
        "actual_at": null,
        "event": "vessel_loaded",
        "index": 2,
        "original_event": "Vessel Loaded",
        "created_at": "2020-04-18T00:18:27Z",
        "voyage_number": "FA009R",
        "location_name": null,
        "location_locode": null,
        "vessel_name": "MSC FAITH",
        "vessel_imo": null,
        "timezone": null
      },
      "relationships": {
        "location": {
          "data": null
        },
        "vessel": {
          "data": {
            "id": "4b473d0e-7073-4171-8b5b-15e71e9e13cc",
            "type": "vessel"
          }
        }
      }
    },
    {
      "id": "ca5862ef-6e27-4245-a281-0cec6bbe1fb7",
      "type": "raw_event",
      "attributes": {
        "timestamp": "2020-03-15T00:00:00Z",
        "estimated": false,
        "actual_on": "2020-03-15",
        "estimated_at": null,
        "actual_at": null,
        "event": "vessel_departed",
        "index": 3,
        "original_event": "Vessel departed",
        "created_at": "2020-04-18T00:18:27Z",
        "voyage_number": "FA009R",
        "location_name": null,
        "location_locode": null,
        "vessel_name": "MSC FAITH",
        "vessel_imo": null,
        "timezone": null
      },
      "relationships": {
        "location": {
          "data": null
        },
        "vessel": {
          "data": {
            "id": "4b473d0e-7073-4171-8b5b-15e71e9e13cc",
            "type": "vessel"
          }
        }
      }
    },
    {
      "id": "f47a903e-e6d1-41c5-aec6-8401b2abf297",
      "type": "raw_event",
      "attributes": {
        "timestamp": "2020-03-25T00:00:00Z",
        "estimated": false,
        "actual_on": "2020-03-25",
        "estimated_at": null,
        "actual_at": null,
        "event": "transshipment_arrived",
        "index": 4,
        "original_event": "Vessel arrived",
        "created_at": "2020-04-18T00:18:27Z",
        "voyage_number": "FA009R",
        "location_name": null,
        "location_locode": null,
        "vessel_name": "MSC FAITH",
        "vessel_imo": null,
        "timezone": null
      },
      "relationships": {
        "location": {
          "data": null
        },
        "vessel": {
          "data": {
            "id": "4b473d0e-7073-4171-8b5b-15e71e9e13cc",
            "type": "vessel"
          }
        }
      }
    },
    {
      "id": "72a1a13b-a2e0-4ac0-851d-eec41e9e9087",
      "type": "raw_event",
      "attributes": {
        "timestamp": "2020-03-25T00:00:00Z",
        "estimated": false,
        "actual_on": "2020-03-25",
        "estimated_at": null,
        "actual_at": null,
        "event": "transshipment_discharged",
        "index": 5,
        "original_event": "Vessel Discharged",
        "created_at": "2020-04-18T00:18:27Z",
        "voyage_number": "FA009R",
        "location_name": null,
        "location_locode": null,
        "vessel_name": "MSC FAITH",
        "vessel_imo": null,
        "timezone": null
      },
      "relationships": {
        "location": {
          "data": null
        },
        "vessel": {
          "data": {
            "id": "4b473d0e-7073-4171-8b5b-15e71e9e13cc",
            "type": "vessel"
          }
        }
      }
    },
    {
      "id": "cd91f0cf-ee73-4c47-b99f-63245cb5bc96",
      "type": "raw_event",
      "attributes": {
        "timestamp": "2020-04-07T00:00:00Z",
        "estimated": false,
        "actual_on": "2020-04-07",
        "estimated_at": null,
        "actual_at": null,
        "event": "transshipment_loaded",
        "index": 6,
        "original_event": "Vessel Loaded",
        "created_at": "2020-04-18T00:18:27Z",
        "voyage_number": "15W10",
        "location_name": null,
        "location_locode": null,
        "vessel_name": "SINGAPORE EXPRESS",
        "vessel_imo": null,
        "timezone": null
      },
      "relationships": {
        "location": {
          "data": null
        },
        "vessel": {
          "data": {
            "id": "345c05ab-4217-4ffe-a1a4-6c03b9ad2b36",
            "type": "vessel"
          }
        }
      }
    },
    {
      "id": "561dbb7e-c3ab-4e63-b09b-957878b1425f",
      "type": "raw_event",
      "attributes": {
        "timestamp": "2020-04-07T00:00:00Z",
        "estimated": false,
        "actual_on": "2020-04-07",
        "estimated_at": null,
        "actual_at": null,
        "event": "transshipment_departed",
        "index": 7,
        "original_event": "Vessel departed",
        "created_at": "2020-04-18T00:18:27Z",
        "voyage_number": "15W10",
        "location_name": null,
        "location_locode": null,
        "vessel_name": "SINGAPORE EXPRESS",
        "vessel_imo": null,
        "timezone": null
      },
      "relationships": {
        "location": {
          "data": null
        },
        "vessel": {
          "data": {
            "id": "345c05ab-4217-4ffe-a1a4-6c03b9ad2b36",
            "type": "vessel"
          }
        }
      }
    },
    {
      "id": "551711a6-62ad-4205-8da2-00e0c0cbd2db",
      "type": "raw_event",
      "attributes": {
        "timestamp": "2020-04-12T00:00:00Z",
        "estimated": false,
        "actual_on": "2020-04-12",
        "estimated_at": null,
        "actual_at": null,
        "event": "vessel_arrived",
        "index": 8,
        "original_event": "Vessel arrived",
        "created_at": "2020-04-18T00:18:27Z",
        "voyage_number": "15W10",
        "location_name": null,
        "location_locode": null,
        "vessel_name": "SINGAPORE EXPRESS",
        "vessel_imo": null,
        "timezone": null
      },
      "relationships": {
        "location": {
          "data": null
        },
        "vessel": {
          "data": {
            "id": "345c05ab-4217-4ffe-a1a4-6c03b9ad2b36",
            "type": "vessel"
          }
        }
      }
    },
    {
      "id": "f4027470-75ca-4e2a-b4f0-47654a25ac48",
      "type": "raw_event",
      "attributes": {
        "timestamp": "2020-04-13T00:00:00Z",
        "estimated": false,
        "actual_on": "2020-04-13",
        "estimated_at": null,
        "actual_at": null,
        "event": "vessel_discharged",
        "index": 9,
        "original_event": "Vessel Discharged",
        "created_at": "2020-04-18T00:18:27Z",
        "voyage_number": "15W10",
        "location_name": null,
        "location_locode": null,
        "vessel_name": "SINGAPORE EXPRESS",
        "vessel_imo": null,
        "timezone": null
      },
      "relationships": {
        "location": {
          "data": null
        },
        "vessel": {
          "data": {
            "id": "345c05ab-4217-4ffe-a1a4-6c03b9ad2b36",
            "type": "vessel"
          }
        }
      }
    },
    {
      "id": "50f11e4f-411e-48e2-8141-64226500df9c",
      "type": "raw_event",
      "attributes": {
        "timestamp": "2020-04-14T00:00:00Z",
        "estimated": false,
        "actual_on": "2020-04-14",
        "estimated_at": null,
        "actual_at": null,
        "event": "full_out",
        "index": 10,
        "original_event": "Truck Departure from",
        "created_at": "2020-04-18T00:18:27Z",
        "voyage_number": null,
        "location_name": null,
        "location_locode": null,
        "vessel_name": null,
        "vessel_imo": null,
        "timezone": null
      },
      "relationships": {
        "location": {
          "data": null
        },
        "vessel": {
          "data": null
        }
      }
    },
    {
      "id": "49aea23c-b8c5-4a97-b133-f7a9723fa1b4",
      "type": "raw_event",
      "attributes": {
        "timestamp": "2020-04-15T00:00:00Z",
        "estimated": false,
        "actual_on": "2020-04-15",
        "estimated_at": null,
        "actual_at": null,
        "event": "empty_in",
        "index": 11,
        "original_event": "Truck Gate in empty",
        "created_at": "2020-04-18T00:18:27Z",
        "voyage_number": null,
        "location_name": null,
        "location_locode": null,
        "vessel_name": null,
        "vessel_imo": null,
        "timezone": null
      },
      "relationships": {
        "location": {
          "data": null
        },
        "vessel": {
          "data": null
        }
      }
    }
  ],
  "included": [
    {
      "id": "4b473d0e-7073-4171-8b5b-15e71e9e13cc",
      "type": "vessel",
      "attributes": {
        "name": "MSC FAITH",
        "imo": null,
        "mmsi": "636019213",
        "latitude": 70.22625823437389,
        "longitude": 45.06279126658865,
        "nautical_speed_knots": 100,
        "navigational_heading_degrees": 1,
        "position_timestamp": "2023-06-05T19:46:18Z"
      }
    },
    {
      "id": "345c05ab-4217-4ffe-a1a4-6c03b9ad2b36",
      "type": "vessel",
      "attributes": {
        "name": "SINGAPORE EXPRESS",
        "imo": null,
        "mmsi": "477300500",
        "latitude": 70.22625823437389,
        "longitude": 45.06279126658865,
        "nautical_speed_knots": 100,
        "navigational_heading_degrees": 1,
        "position_timestamp": "2023-06-05T19:46:18Z"
      }
    }
  ]
}
```

### Response Fields

| Field                                | Type        | Description                                                                                                                                                                                                |
| ------------------------------------ | ----------- | ---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- |
| `data[].id`                          | string      | Unique identifier for the raw event                                                                                                                                                                        |
| `data[].type`                        | string      | Resource type (always `raw_event`)                                                                                                                                                                         |
| `data[].attributes.timestamp`        | string      | ISO 8601 timestamp of the event                                                                                                                                                                            |
| `data[].attributes.estimated`        | boolean     | Whether the event is estimated                                                                                                                                                                             |
| `data[].attributes.actual_on`        | string/null | Event’s local calendar date (if available)                                                                                                                                                                 |
| `data[].attributes.estimated_at`     | string/null | Time the estimate was produced                                                                                                                                                                             |
| `data[].attributes.actual_at`        | string/null | Exact actual timestamp (if available)                                                                                                                                                                      |
| `data[].attributes.event`            | string      | Normalized event type (e.g., `empty_out`, `full_in`, `vessel_loaded`, `vessel_departed`, `transshipment_arrived`, `transshipment_loaded`, `transshipment_departed`, `vessel_arrived`, `vessel_discharged`) |
| `data[].attributes.index`            | number      | Sequence index of this event                                                                                                                                                                               |
| `data[].attributes.original_event`   | string/null | Original carrier-provided event text                                                                                                                                                                       |
| `data[].attributes.created_at`       | string      | When this event record was created                                                                                                                                                                         |
| `data[].attributes.voyage_number`    | string/null | Voyage number if applicable                                                                                                                                                                                |
| `data[].attributes.location_name`    | string/null | Human-readable location name                                                                                                                                                                               |
| `data[].attributes.location_locode`  | string/null | UN/LOCODE of location                                                                                                                                                                                      |
| `data[].attributes.vessel_name`      | string/null | Name of vessel (if applicable)                                                                                                                                                                             |
| `data[].attributes.vessel_imo`       | string/null | IMO number of vessel (if applicable)                                                                                                                                                                       |
| `data[].attributes.timezone`         | string/null | Timezone of the event timestamps                                                                                                                                                                           |
| `data[].relationships.location.data` | object/null | Linked location resource identifier                                                                                                                                                                        |
| `data[].relationships.vessel.data`   | object/null | Linked vessel resource identifier                                                                                                                                                                          |

## Event Types

Raw events include the following event types:

* **empty\_out**: Container emptied out
* **full\_in**: Container filled in
* **vessel\_loaded**: Container loaded onto vessel
* **vessel\_departed**: Vessel departed with container
* **transshipment\_arrived**: Container arrived at transshipment port
* **transshipment\_loaded**: Container loaded at transshipment
* **transshipment\_departed**: Container departed transshipment
* **vessel\_arrived**: Vessel arrived at destination
* **vessel\_discharged**: Container discharged from vessel
* **full\_out**: Container filled out
* **empty\_in**: Container emptied in

## Status Codes

| Code | Description                             |
| ---- | --------------------------------------- |
| 200  | Raw events retrieved successfully       |
| 404  | Container not found                     |
| 401  | Authentication failed - invalid API key |
| 429  | Rate limit exceeded                     |
